Object subclass: #SpriteColorMap
	instanceVariableNames: 'position extent rows '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-Sprites'!

!SpriteColorMap methodsFor: 'change colors' stamp: 'RPB 4/5/2011 21:27'!
asBlackAndWhite

	| blackAndWhite bwRows row bwRow cols |
	blackAndWhite _ self partialCopy.
	bwRows _ blackAndWhite rows.
	cols _ rows first size.
	1 to: bwRows size do: [:iRow |
		bwRow _ bwRows at: iRow.
		row _ rows at: iRow.
		1 to: cols do: [:index |
			bwRow at: index put: (row at: index) asBlackOrWhite]].
	^blackAndWhite
			
			
	
	
	! !

!SpriteColorMap methodsFor: 'change colors' stamp: 'RPB 4/4/2011 18:30'!
asMonochrome

	self error:  'Implement me'
	
	! !


!SpriteColorMap methodsFor: 'accessing' stamp: 'RPB 4/4/2011 18:29'!
extent

	^extent! !

!SpriteColorMap methodsFor: 'accessing' stamp: 'RPB 4/4/2011 18:29'!
extent: aPoint

	extent _ aPoint! !

!SpriteColorMap methodsFor: 'accessing' stamp: 'RPB 4/4/2011 18:29'!
position

	^position! !

!SpriteColorMap methodsFor: 'accessing' stamp: 'RPB 4/4/2011 18:30'!
position: aPoint

	^position _ aPoint.! !

!SpriteColorMap methodsFor: 'accessing' stamp: 'RPB 4/4/2011 18:28'!
rows

	^rows! !

!SpriteColorMap methodsFor: 'accessing' stamp: 'RPB 4/4/2011 18:28'!
rows: newRows

	rows _ newRows! !


!SpriteColorMap methodsFor: 'private' stamp: 'RPB 4/4/2011 16:33'!
partialCopy

	| copy emptyRows rowSize |
	copy _ self class new.
	copy extent: self extent.
	copy position: self position.
	emptyRows _ Array new: rows size.
	rowSize := rows first size.
	1 to: rows size do: [:rowIndex |
		emptyRows at: rowIndex put: (Array new: rowSize)].
	copy rows: emptyRows.
			
	! !


!SpriteColorMap methodsFor: 'initialization' stamp: 'CWB 5/12/2012 14:13'!
initialize: aScratchSpriteMorph

	position _ aScratchSpriteMorph position.
	rows _ (aScratchSpriteMorph costumeAtIndex: 1) form asColorMatrix.
	extent _ (rows first size) @ (rows size).! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SpriteColorMap class
	instanceVariableNames: ''!

!SpriteColorMap class methodsFor: 'instance creation' stamp: 'RPB 4/4/2011 14:47'!
fromSprite: aScratchSpriteMorph

	^super new initialize: aScratchSpriteMorph! !
