NXTSensor subclass: #NXTPilotX1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting-NXT Peripherals'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NXTPilotX1 class
	instanceVariableNames: ''!

!NXTPilotX1 class methodsFor: 'dropdown lists' stamp: 'CWB 11/24/2012 14:25'!
customListNumber: aNumber
"Peripherals can return custom lists (or nil)."

	(aNumber = 1) ifTrue: [
		"units of measure"
		^ #('mm' 'cm' 'm ' 'in' 'ft' 'yd')	
	].
	(aNumber = 2) ifTrue: [
		"Forward and backward"
		"^ { UTF8 upwardsBlackArrow . UTF8 downwardsBlackArrow }."
		^ #('img:forward' 'img:backward').
	].
	(aNumber = 3) ifTrue: [
		"Directions to drive in an arc"
		"^ { 
			UTF8 blackLeftPointingTriangle 			, UTF8 boxDrawingsLightArcDownAndLeft .
			UTF8 boxDrawingsLightArcDownAndRight , UTF8 blackRightPointingTriangle . 
			UTF8 blackLeftPointingTriangle 			, UTF8 boxDrawingsLightArcUpAndLeft .
			UTF8 boxDrawingsLightArcUpAndRight 	, UTF8 blackRightPointingTriangle 
		}."
		^ #(
			'img:arcForwardAndLeft'
			'img:arcForwardAndRight'
			'img:arcBackwardAndLeft'
			'img:arcBackwardAndRight'
		).
	].

	^ nil.! !


!NXTPilotX1 class methodsFor: 'accessing' stamp: 'CWB 9/15/2012 20:36'!
concreteTypes
"Returns a list of physical devices that implement the functions of this class."


	^ #( ).! !


!NXTPilotX1 class methodsFor: 'block specs' stamp: 'CWB 12/20/2012 11:20'!
providesBlocks
"Returns a list of block specifications to be used in the main user interface if there is any device configured that can use these blocks."

	| blocks |
	
	blocks _ #(
		'driving'
			('X1 from %P in Test %j %k %q' 		r	NXTPilotX1:madeUp:)
		).

	^ blocks  ! !
